using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Printing;
using System.Drawing.Drawing2D;

namespace Ex4_SMDI
{
    public partial class TopForm : Form
    {
        
        OpenFileDialog m_openFileDialog = new OpenFileDialog(); 

        public TopForm()
        {
            InitializeComponent();
            Application.Idle += new EventHandler(Application_Idle);
            richTextToolStripMenuItem_Click(this, EventArgs.Empty);
        }

        void Application_Idle(object sender, EventArgs e)
        {
            
        }

        void OpenFile(string filename)
        {            
            using (StreamReader reader = new StreamReader(filename))
            {
                
            }
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            
            m_openFileDialog.Dispose();
            Application.Idle -= Application_Idle;
            
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (m_openFileDialog.ShowDialog() == DialogResult.OK)
            {
                
            }
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void cutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (SaveFileDialog dlg = new SaveFileDialog())
            {
                if (dlg.ShowDialog() == DialogResult.OK)
                {
                   
                }
            }
        }

        void SaveFile(String filename, String text)
        {
            using (StreamWriter writer = new StreamWriter(filename))
            {
                writer.Write(text);
            }
        }

        private void colorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            using (ColorDialog dlg = new ColorDialog())
            {
                
            }
        }

        private void TopForm_Load(object sender, EventArgs e)
        {

        }        

        private void viewToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            richTextToolStripMenuItem.Checked = !m_bRectangle;
            richTextToolStripMenuItem.Enabled = m_bRectangle;
            rectangleToolStripMenuItem.Checked = m_bRectangle;
            rectangleToolStripMenuItem.Enabled = !m_bRectangle;
            zoomToolStripMenuItem.Enabled = m_bRectangle;
        }

        bool m_bRectangle = false;
        private void richTextToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SuspendLayout();
            panelRectangle.Visible = false;
            panelRectangle.Dock = DockStyle.None;
            richTextBox.Visible = true;
            richTextBox.Dock = DockStyle.Fill; 
            m_bRectangle = false;
            ResumeLayout(true);
        }

        private void rectangleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SuspendLayout();
            richTextBox.Visible = false;
            richTextBox.Dock = DockStyle.None;
            panelRectangle.Visible = true;
            panelRectangle.Dock = DockStyle.Fill;
            m_bRectangle = true;
            ResumeLayout(true);
        }

        Rectangle m_rectDraw = new Rectangle(0, 0, 100, 150);
        Rectangle m_ellipseDraw = new Rectangle(100, 100, 100, 150);        
        private void panelRectangle_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            using (HatchBrush brush = new HatchBrush(HatchStyle.Trellis, Color.Aquamarine, Color.Bisque))
            {
               g.FillRectangle(brush, m_rectDraw);
            }
            g.DrawRectangle(Pens.Black, m_rectDraw);
            using (LinearGradientBrush brush = new LinearGradientBrush(m_ellipseDraw,
                Color.White, Color.Black, 45f))
            {
                g.FillEllipse(brush, m_ellipseDraw);
            }
            g.DrawEllipse(Pens.Black, m_ellipseDraw);            
        }

        bool m_bDragRect = false;
        bool m_bDragEllipse = false;
        Point m_ptDown;
        Rectangle m_rectInvalid;
        private void panelRectangle_MouseDown(object sender, MouseEventArgs e)
        {
            Point ptMouse = e.Location;
            if (m_rectDraw.Contains(ptMouse))
            {
                m_bDragRect = true;
                m_ptDown = ptMouse;
                m_rectInvalid = new Rectangle(m_rectDraw.Location, m_rectDraw.Size);
                m_rectInvalid.Inflate(2, 2);
            }
            using (GraphicsPath path = new GraphicsPath())
            {
                path.AddEllipse(m_ellipseDraw);
                using (Region region = new Region(path))
                {
                    if (region.IsVisible(ptMouse))
                    {
                        m_bDragEllipse = true;
                        m_ptDown = ptMouse;
                        m_rectInvalid = new Rectangle(m_ellipseDraw.Location, m_ellipseDraw.Size);
                        m_rectInvalid.Inflate(2, 2);
                    }
                }
            }
        }

        private void panelRectangle_MouseMove(object sender, MouseEventArgs e)
        {
            Point ptMouse = e.Location;
            if (m_bDragRect)
            {
                panelRectangle.Invalidate(m_rectInvalid);
                m_rectDraw.Offset(
                    ptMouse.X - m_ptDown.X,
                    ptMouse.Y - m_ptDown.Y
                );
                m_ptDown = ptMouse;
                m_rectInvalid = m_rectDraw;
                m_rectInvalid.Inflate(2, 2);
                panelRectangle.Invalidate(m_rectInvalid);
            }
            if (m_bDragEllipse)
            {
                panelRectangle.Invalidate(m_rectInvalid);
                m_ellipseDraw.Offset(
                    ptMouse.X - m_ptDown.X,
                    ptMouse.Y - m_ptDown.Y
                );
                m_ptDown = ptMouse;
                m_rectInvalid = m_ellipseDraw;
                m_rectInvalid.Inflate(2, 2);
                panelRectangle.Invalidate(m_rectInvalid);
            }
        }

        private void panelRectangle_MouseUp(object sender, MouseEventArgs e)
        {
            m_bDragRect = false;
            m_bDragEllipse = false;
        }

        private void toolStripMenuItemZoom_Click(object sender, EventArgs e)
        {
            panelRectangle.Invalidate(true);
        }

        private void fontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (FontDialog dlg = new FontDialog())
            {
                if (dlg.ShowDialog() == DialogResult.OK)
                {

                }
            }
        }



    }
}